/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.job.webapp;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import net.sourceforge.kivu4j.utils.action.JSONActionSupport;
import net.sourceforge.kivu4j.utils.action.ResponseList;
import net.sourceforge.kivu4j.utils.lang.domain.NameValue;


/**
 * 
 *
 * @author Lucky Yang
 */
public class JobappAction extends JSONActionSupport {
	/**
	 * 所有的任务组。
	 * 
	 * @return
	 */
	public String loadGroups(){
		try{
			// 过滤重复的组
			Set<String> groups = new HashSet<String>();
			for(Jobs job : Jobs.values()){
				groups.add(job.getGroup());
			}		
			
			List<NameValue> rslt = new ArrayList<NameValue>(groups.size());
			for(String group:groups){
				rslt.add(new NameValue(group, group));
			}
			this.setResponseData(new ResponseList<NameValue>(rslt));
		}catch(Exception e){
			this.handleException(e);
		}
		return SUCCESS;
	}		
}
