/**
 * Kivu4j. Copyright (C) 2010 . see<http://kivu4j.sourceforge.net />

   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses />.
 */

package net.sourceforge.kivu4j.job.webapp;

import javax.annotation.Resource;

import net.sourceforge.kivu4j.job.services.TimetableManager;
import net.sourceforge.kivu4j.utils.job.AbstractProcessor;
import net.sourceforge.kivu4j.utils.job.ScheduleManager;

import org.quartz.JobExecutionContext;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

/**
 * 守护服务
 *
 * @author Lucky Yang
 */
@Service("onDemandProcessor")
public class OnDemandProcessor extends AbstractProcessor {

	protected Logger logger = LoggerFactory.getLogger(getClass());
	@Resource
	private TimetableManager timetableManager;
	@Resource
	private ScheduleManager scheduleManager;
	
	@Override
	public void doProcess(JobExecutionContext context) {		
		try{
			// 循环所有定义的job
			for(Jobs job:Jobs.values()){
				// 发布job
				this.scheduleManager.addJob(job.getName(), job.getGroup(), job.getClazz(), job.getDescription());
				
				// 检查job，是否有新的，修改的，或删除的时间表
				this.timetableManager.validateTheJob(job.getName(), job.getGroup());
				
			}
		}catch(Exception e){
			logger.error("ERROR", e);
		}
	}
}
